# -*- coding:utf-8 -*-

# StartOS Device Manager(ydm).
# Copyright (C) 2012 ivali, Inc.
# hechao <hechao@ivali.com>, 2011.
import os

R = 15
D = 20
S = 6
DEV_ID = 0
DRI_ID = 1
TEST_ID = 2
ICON = "/usr/share/ydevicemanager/"
LOGO = "/usr/share/ydevicemanager/logo/"

DEFAULT_FONT = "WenQuanYi Micro Hei"
DEFAULT_FONT_SIZE = 13

DEFAULT_WIDTH = 900
DEFAULT_HEIGHT = 666

CONFIG = "/etc/yget.conf"
DBUS_IFACE = 'com.startos.ydm'
DBUS_PATH = '/com/startos/ydm'

HOME = os.path.expanduser("~")
#HOME = os.environ['HOME']
TARGET_DIR = HOME + "/.ydm"
if not os.path.isdir(TARGET_DIR):
    #os.system("mkdir -p %s" %TARGET_DIR)
    os.mkdir(TARGET_DIR)
HW_XML = TARGET_DIR + "/device.xml"
TAR_XML = TARGET_DIR + "/device.tar"
TEST_Z = TARGET_DIR + "/computer"
RUN_DIR = os.path.abspath(os.path.dirname(__file__))

C_Errno = 1
P_Errno = 2

VENDORS = {
    #CPU产商
    "INTEL":["INTEL.jpg", "www.intel.com", "Intel"],
    "AMD":["AMD.jpg", "www.amd.com", "AMD"],
    "PHYTIUM":["PHYTIUM.jpg", "www.phytium.com.cn", "Phytium"],
    "VIMICRO":["VIMICRO.jpg", "www.vimicro.com", "Vimicro"],
    "C-QUADCORE":["ZHAOXIN.jpg", "www.zhaoxin.com", "Zhaoxin"],
    "SHANGHAI":["ZHAOXIN.jpg", "www.zhaoxin.com", "Zhaoxin"],
    "CENTAURHAULS":["ZHAOXIN.jpg", "www.zhaoxin.com", "Zhaoxin"],
    "HYGONGENUINE":["HYGON.jpg", "www.hygon.com", "Hygon"],
    "HYGON":["HYGON.jpg", "www.hygon.com", "Hygon"],
    "LOONGSON":["LOONGSON.jpg", "www.loongson.cn", "Loongson"],
    "SUNWAY":["SHENWEI.jpg", "www.swcpu.cn", "SUNWAY"],
    #显卡产商
    "ATI":["ATI.jpg", "www.ati.com", "ATI"],
    "1002":["ATI.jpg", "www.ati.com", "ATI"],
    "1039":["SIS.jpg", "www.sis.com", "SIS"],
    "NVIDIA":["NVIDIA.jpg", "www.nvidia.com", "Nvidia"],
    "VIA":["VIA.jpg", "www.via.com.tw", "VIA"],
    "XFX":["XFX.jpg", "www.xfx.com.cn", "XFX"],
    "SUPERGRAPHIC":["SUPERGRAPHIC.jpg", "www.supergraphic.com.cn", "Supergraphic"],
    "ZHAOXIN":["ZHAOXIN.jpg", "www.zhaoxin.com", "Zhaoxin"],
    "ASPEED":["ASPEED.jpg", "www.aspeedtech.com", "ASPEED"],
    #显示器产商
    "AUO":["AUO.jpg", "www.auo.com", "AUO"],
    "AOC":["AOC.jpg", "www.aoc.com", "AOC"],
    "PHILIPS":["PHILIPS.jpg", "www.philips.com", "Philips"],
    "PHL":["PHILIPS.jpg", "www.philips.com", "Philips"],
    "LEN":["LENOVO.jpg", "www.lenovo.com", "Lenovo"],
    "SEC":["SAMSUNG.jpg", "www.samsung.com", "SAMSUNG"],
    "CMN":["CMO.jpg", "www.cmo.com.tw", "CMO"],
    #电脑品牌
    "HASEE":["HASEE.jpg", "www.hasee.com", "Hasee"],
    "FOUNDER":["FOUNDER.jpg", "www.founderpc.com", "Founder"],
    "FND":["FOUNDER.jpg", "www.founderpc.com", "Founder"],
    "TONGFANG":["TONGFANG.jpg", "www.tongfangpc.com", "Tongfang"],
    "TSINGHUA":["TONGFANG.jpg", "www.tongfangpc.com", "Tongfang"],
    "THTF":["TONGFANG.jpg", "www.tongfangpc.com", "Tongfang"],
    "ACER":["ACER.jpg", "www.acer.com", "Acer"],
    "LENOVO":["LENOVO.jpg", "www.lenovo.com", "Lenovo"],
    "ASUSTEK":["ASUS.jpg", "www.asus.com", "ASUS"],
    "NEC":["NEC.jpg", "www.nec.com", "NEC"],
    "HP":["HP.jpg", "www.hp.com", "HP"],
    "HEWLETT-PACKARD":["HP.jpg", "www.hp.com", "HP"],
    "SAMSUNG":["SAMSUNG.jpg", "www.samsung.com", "SAMSUNG"],
    "TOSHIBA":["TOSHIBA.jpg", "www.toshiba.com", "TOSHIBA"],
    "APPLE":["APPLE.jpg", "www.apple.com", "Apple"],
    "DELL":["DELL.jpg", "www.dell.com", "DELL"],
    "DEL":["DELL.jpg", "www.dell.com", "DELL"],
    "FUJITSU":["FUJITSU.jpg", "www.fujitsu.com", "FUJITSU"],
    "SONY":["SONY.jpg", "www.sony.com", "SONY"],
    "IBM":["IBM.jpg", "www.ibm.com", "IBM"],
    "SUGON":["SUGON.jpg", "www.sugon.com", "Sugon"],
    "GREATWALL":["GREATWALL.jpg", "gwssi.com.cn", "Greatwall"],
    #虚拟机
    "INNOTEK":["VIRTUALBOX.jpg", "www.virtualbox.org", "VirtualBox"],
    "VBOX":["VIRTUALBOX.jpg", "www.virtualbox.org", "VirtualBox"],
    "VIRTUALBOX":["VIRTUALBOX.jpg", "www.virtualbox.org", "VirtualBox"],
    #网卡产商
    "3COM":["3COM.jpg", "www.3com.com", "3COM"],
    "D-LINK":["D-LINK.jpg", "www.dlink.com.tw", "D-LINK"],
    "RALINK":["RALINK.jpg", "www.ralinktech.com", "Ralink"],
    "ATHEROS":["ATHEROS.jpg", "www.atheros.com", "Atheros"],
    "QUALCOMM":["ATHEROS.jpg", "www.atheros.com", "Qualcomm"],
    "MARVELL":["MARVELL.jpg", "www.marvell.com", "Marvell"],
    "BROADCOM":["BROADCOM.jpg", "www.broadcom.com", "Broadcom"],
    "ASIX":["ASIX.jpg", "www.asix.com.tw", "ASIX"],
    #硬盘产商
    "EXCELSTOR":["EXCELSTOR.jpg", "www.excelstor.com", "Excelstor"],
    "HITACHI":["HITACHI.jpg", "www.hitachi.com", "Hitachi"],
    "MAXTOR":["MAXTOR.jpg", "www.maxtor.com", "Maxtor"],
    "WESTERN":["WDC.jpg", "www.wdc.com", "Western Digital"],
    "ELEMENTS":["WDC.jpg", "www.wdc.com", "Elements"],
    "LITEON":["LITEON.jpg", "www.liteonit.com", "Liteon"],
    "SEAGATE":["SEAGATE.jpg", "www.seagate.com", "Seagate"],
    "QUANTUM":["QUANTUM.jpg", "www.quantum.com", "Quantum"],
    "VBOX_HARDDISK":["VIRTUALBOX.jpg", "www.virtualbox.org", "VirtualBox"],
    "SSDE600MS30240C-":["SSDE600MS30240C-.jpg", "www.gokemicro.com", "GokeDisk"],
    "HGST":["HGST.jpg", "www.westerndigital.com", "HGSTDisk"],
    #光驱产商
    "PLDS":["PLDS.jpg", "www.pldsnet.com", "PLDS"],
    "PBDS":["PLDS.jpg", "www.pldsnet.com", "PLDS"],
    "HL-DT-ST":["LG.jpg", "www.lge.com", "LG"],
    "OPTIARC":["SONY.jpg", "www.sony-optiarc.com", "SONY"],
    "TSSTCORP":["TSSTCORP.jpg", "www.tsstorage.com", "TSSTcorp"],
    "PIONEER":["PIONEER.jpg", "www.pioneerchina.com", "Pioneer"],
    "MATSHITA":["PANASONIC.jpg", "www.panasonic.cn", "Panasonic"],
    "SLIMTYPE":["LITEON.jpg", "www.liteonit.com", "Liteon"],
    #声卡产商
    "REALTEK":["REALTEK.jpg", "www.realtek.com.tw", "Realtek"],
    "CREATIVE":["CREATIVE.jpg", "www.creative.com", "Creative"],
    #摄像头
    "SONIX":["SONIX.jpg", "www.sonix.com.tw", "Sonix"],
    "ETRON":["ETRON.jpg", "www.etron.com.tw", "Etron"],
    "AVEO":["AVEO.jpg", "www.aveotek.com", "Aveotek"],
    "SYNTEK":["SYNTEK.jpg", "www.stk.com.tw", "Syntek"],
    "EMPIA":["EMPIA.jpg", "www.empiatech.com.tw", "EETI"],
    "CHICONY":["CHICONY.jpg", "www.chicony.com.tw", "Chicony"],
    "OMNIVISION":["OMNIVISION.jpg", "www.ovt.com", "OmniVision"],
    "SUNPLUSIT":["SUNPLUSIT.jpg", "http://www.sunplusit.com", "Sunplus"],
    #鼠标产商
    "LOGITECH":["LOGITECH.jpg", "www.logitech.com", "Logitech"],
    "SUNPLUS":["SUNPLUS.jpg", "www.sunplus.com", "Sunplus"],
    "PRIMAX":["PRIMAX.jpg", "www.primax.com.cn", "Primax"],
    "PIXART":["PIXART.jpg", "www.pixart.com.tw", "Pixart"],
    "TRUST":["TRUST.jpg", "www.trust.com", "Trust"],
    "1BCF":["RAPOO.jpg", "www.rapoo.com", "Rapoo"],
    "AVAGO":["AVAGO.jpg", "www.avagotech.cn", "Avago"],
    "MICROSOFT":["MICROSOFT.jpg", "www.microsoft.com", "Microsoft"],
    #键盘产商
    "RAPOO":["RAPOO.jpg", "www.rapoo.com", "Rapoo"],
    "NOVATEK":["NOVATEK.jpg", "www.novatek.com.tw", "NOVATEK"],
    "04D9":["HOLTEK.jpg", "www.holtek.com.tw", "HOLTEK"],
    #主板产商
    "GIGABYTE":["GIGABYTE.jpg", "www.gigabyte.com.tw", "Gigabyte"],
    "BIOSTAR":["BIOSTAR.jpg", "www.biostar.com.tw", "Biostar"],
    "COLORFUL":["COLORFUL.jpg", "www.colorful.cn", "Colorful"],
    "YESTON":["YESTON.jpg", "www.yeston.net", "Yeston"],
    "QINGHUATONGFANG":["TONGFANG.jpg", "www.tongfangpc.com", "Tongfang"],
    "SUMA":["SUMA.jpg", "www.cancon.com.cn", "Suma"],
    "CANCON":["SUMA.jpg", "www.cancon.com.cn", "Suma"],
    "CD":["SHENWEI.jpg", "www.swcpu.cn", "CD SUNWAY"],
    #指纹识别
    "UPEK":["AUTHENTEC.jpg", "www.authentec.com", "Authentec"],
    "AUTHENTEC":["AUTHENTEC.jpg", "www.authentec.com", "Authentec"],
    "FOCAL-SYSTEMS":["FOCAL.jpg", "www.focaltech-electronics.com", "Focaltech"],
    "ARATEK":["ARATEK.jpg", "www.aratek.co", "Aratek"],
    #闪存产商
    "KINGSTON":["KINGSTON.jpg", "www.kingston.com", "Kingston"],
    "KINGMAX":["KINGMAX.jpg", "www.kingmax.com", "Kingmax"],
    "KINGBOX":["KINGBOX.jpg", "www.kingbox.com.tw", "Kingbox"],
    "HYNIX":["HYNIX.jpg", "www.hynix.com", "Hynix"],
    "HYUNDAI":["HYNIX.jpg", "www.hynix.com", "Hynix"],
    "SKHYNIX":["HYNIX.jpg", "www.hynix.com", "Hynix"],
    "SK":["HYNIX.jpg", "www.hynix.com", "Hynix"],
    "MICRON":["MICRON.jpg", "www.micron.com", "Micron"],
    "06C1":["ASINT.jpg", "www.asinttech.com", "Asint"],
    "ADATA":["ADATA.jpg", "www.adata.com.cn", "ADATA"],
    "ZTE":["ZTE.jpg", "www.zte.com.cn", "ZTE"],
    "EAGET":["EAGET.jpg", "www.eaget.com.cn", "Eaget"],
    "TEXAS":["TEXAS.jpg", "www.ti.com", "Texas Instruments"],
    "TIGO":["TIGO.jpg", "www.tigo.com.hk", "Tigo"],
    "KIMTIGO":["TIGO.jpg", "www.tigo.com.hk", "Tigo"],
    "AGILENT":["AGILENT.jpg", "www.agilent.com.cn", "Agilent"],
    "INNOSTOR":["INNOSTOR.jpg", "www.innostor.com", "Innostor"],
    "RAMAXEL":["RAMAXEL.jpg", "www.ramaxel.com", "Ramaxel"],
    "CHENGDU":["HAIGUANG.jpg", "www.haiguang.com", "Chengdu Haiguang"],
    "INMOS":["INMOS.jpg", "http:www.unisemicon.com", "guoxinmicro"],
    "UNIIC":["UNIIC.jpg", "unisemicon.com", "UniIC"],
    #电源产商
    "SMP":["SMP.jpg", "www.simplo.com.tw", "SMP"],
    #BIOS产商
    "AMERICAN":["AMI.jpg", "www.ami.com", "AMI"],
    "AWARD":["PHOENIX.jpg", "www.award-bios.com", "Phoenix"],
    "PHOENIX":["PHOENIX.jpg", "www.phoenix.com", "Phoenix"],
    "ZD":["ZD.jpg", "www.cetc.com.cn", "China Electronics Tech"],
    "BYOSOFT":["BYOSOFT.jpg", "www.byo.com", "Byo"],
    #USB设备
    "ZHONG":["ZHONGFU.jpg", "m.zhongfu.net", "Zhong FU"],
    #其他
    "ASMEDIA":["ASMEDIA.jpg", "www.asmedia.com.tw", "ASMedia"]
}
